import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class GUI extends Applet {
    AudioClip sound;
    Image background;

    private Button newButton(String label, ActionListener al) {
       Button b = new Button(label);
       b.addActionListener(al);
       return b;
    }

    public void init() {
	background = getImage(getCodeBase(), getParameter("image"));
	sound = getAudioClip(getCodeBase(), getParameter("sound"));

	setLayout(new BorderLayout());
	Panel buttons = new Panel();
	buttons.setBackground(Color.white);

	buttons.add( newButton("Play", new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		sound.play();
		showStatus("playing");
	    }} ) );
	buttons.add( newButton("Stop", new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		sound.stop();
		showStatus("stopped");
	    }} ) );
	buttons.add( newButton("Loop", new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		sound.loop();
		showStatus("looping");
	    }} ) );

	add("South", buttons);
    }

    public void paint(Graphics g) {
	g.drawImage(background,0,0,this);
    }
}
