import java.sql.*;

public class Transaction  {
  public static void main(String [] args){
   try { 
    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver"); 
    String url = "jdbc:odbc:supplier-part";
    Connection con = 
	DriverManager.getConnection(url, "", "");
    updatedb(con);
    con.close();
   } catch(Exception e) {
    System.err.println("Exception: " +
	                e.getMessage());
   }
  }

  static void updatedb(Connection con)
    throws SQLException 
  {
    String insertCity =
     "INSERT INTO CITY (CNO, CNAME) VALUES (?,?);";
    PreparedStatement psInsertCity =
      con.prepareStatement(insertCity);

    String insertSupplier =
      "INSERT INTO SUPPLIER (SNO, SNAME, CNO) VALUES (?,?,?)";
    PreparedStatement psInsertSupplier =
      con.prepareStatement(insertSupplier);

    String insertSells="INSERT INTO SELLS (SNO, PNO, PRICE) VALUES (?,?,?);";
    PreparedStatement psInsertSells =
      con.prepareStatement(insertSells);

    con.setAutoCommit(false);
    try{
      psInsertCity.setInt(1,5);
      psInsertCity.setString(2,"Toronto");
      psInsertCity.executeUpdate();

      psInsertSupplier.setInt(1,5);
      psInsertSupplier.setString(2,"Bill");
      psInsertSupplier.setInt(3,5);
      psInsertSupplier.executeUpdate();
	
      psInsertSells.setInt(1,5);
      psInsertSells.setInt(2,1);
      psInsertSells.setDouble(3,2.50);
      psInsertSells.executeUpdate();

      psInsertSells.setInt(1,5);
      psInsertSells.setInt(2,2);
      psInsertSells.setDouble(3,3.50);
      psInsertSells.executeUpdate();

      con.commit();
    } catch(SQLException ex) {
      con.rollback();
      System.err.println("SQLException: " +
	                  ex.getMessage());
      System.err.println(
      "Database rolled back before inserting Bill");
    }
    con.setAutoCommit(true);
  }
}
