import java.sql.*;
public class Examples {
    public static void main(String [] args){
	Connection con;
	try { 
	    // Load the JDBC-ODBC bridge driver
	    Class.forName("sun.jdbc.odbc.JdbcOdbcDriver"); 

	    // Should have a odbc datasource with the name supplier-part
	    String url = "jdbc:odbc:supplier-part";

	    // This database requires no userid/password to login
	    con = DriverManager.getConnection(url, "", "");

	    // Get a statement (used to issue SQL statements to the DB)
	    Statement stmt = con.createStatement();

	    //int rowsEffected=stmt.executeUpdate("INSERT INTO PART (PNO, PNAME ) VALUES (5,'Hammer');");
	    //System.out.println("rowsEffected="+rowsEffected);
			
	    // A PreparedStatement is a parameterized SQL statement
	    //String insertSells="INSERT INTO SELLS (SNO, PNO) VALUES (?,?);";
	    //PreparedStatement ps = con.prepareStatement(insertSells);
	    //ps.setInt(1,1); // Fill in the first ?
	    //ps.setInt(2,2); // Fill in the second ?
	    //rowsEffected=ps.executeUpdate(); 
	    //System.out.println("rowsEffected="+rowsEffected);
	    //ps.close();

	    String query="SELECT * FROM PART;";
	    System.out.println(query);

	    // Send the query to the DB
	    // A ResultSet is returned when we execute a search query. 
	    // This allows us to scroll through the rows of the result 
	    // table one row at a time
	    ResultSet rs = stmt.executeQuery(query);

	    // Go through all rows returned by the query
	    while(rs.next()){
		// Pull out individual columns from the current row
		int pno=rs.getInt("PNO");
		String pname=rs.getString("PNAME");
	
		// Print out the values
		System.out.println(pno+"\t"+pname);
	    } 
	    rs.close();
	    stmt.close();
	    con.close();
	} catch(Exception e) {
	    System.err.println("Exception: " + e.getMessage());
	}
    }
}
